<template>
  <div class="baseprice-monitor-filter-panel">

    <div class="baseprice-monitor-filter-panel__item">
      <ObRadio
        label="По локациям"
        :valueInput="'LOCATION'"
        v-model="filterData.type"
        @change="changeFilterData"
        data-qa="radioLocationBP"
      />
      <ObRadio
        label="По кластерам"
        :valueInput="'CLUSTER'"
        v-model="filterData.type"
        @change="changeFilterData"
        data-qa="radioClusterBP"
      />
    </div>

      <div class="baseprice-monitor-filter-panel__item select-item" v-show="filterData.type === 'LOCATION'">
        <ObAddressInput
            v-model="filterData.locationFrom"
            title="Откуда"
            :prefixIcon="filterData.locationFrom && filterData.locationFrom.icon || ''"
            placeholder="Введите адрес"
            :show-map="false"
            @input="setAddressFrom"
            @on-change-address="setAddressFrom"
            data-qa="addressInputlocationFromBP"
            ref="locationFromInput"
        />
      </div>
      <div class="baseprice-monitor-filter-panel__item select-item" v-show="filterData.type === 'LOCATION'">
        <ObAddressInput
            v-model="filterData.locationTo"
            title="Куда"
            :prefixIcon="filterData.locationTo && filterData.locationTo.icon || ''"
            placeholder="Введите адрес"
            :show-map="false"
            @input="setAddressTo"
            @on-change-address="setAddressTo"
            data-qa="addressInputlocationToBP"
            ref="locationToInput"
        />
      </div>
      <div class="baseprice-monitor-filter-panel__item" v-show="filterData.type === 'CLUSTER'">
        <ObControlGroup
            :items="groupItems"
            v-model="filterData.transportationWay"
            theme="light"
            @input="changeFilterData"
            data-qa="controlGroupTransportationWayBP"
        />
      </div>
      <div class="baseprice-monitor-filter-panel__item select-item" v-show="showClusterFTL">
        <ObSelect
            v-model="filterData.cluster"
            label="Кластер"
            placeholder="Укажите кластер"
            displayExp="title"
            :items="clustersFiltered"
            :is-clearable="true"
            :isSearch="true"
            :is-auto-complete="false"
            @input="changeFilterData"
            data-qa="selectClusterBP"
        />
      </div>
      <div class="baseprice-monitor-filter-panel__item select-item" v-show="showClusterFTL">
        <ObSelect
            v-model="filterData.clusterLocationFrom"
            label="Откуда"
            placeholder="Укажите локацию"
            displayExp="russian_name"
            :items="locationsFrom"
            :isSearch="true"
            :is-auto-complete="false"
            :is-clearable="true"
            @input="changeFilterData"
            :clear-item="clearItem"
            data-qa="selectClusterLocationFromBP"
        />
      </div>
      <div class="baseprice-monitor-filter-panel__item select-item" v-show="showClusterFTL">
        <ObSelect
            v-model="filterData.clusterLocationTo"
            label="Куда"
            placeholder="Укажите локацию"
            displayExp="russian_name"
            :items="locationsTo"
            :isSearch="true"
            :is-auto-complete="false"
            :is-clearable="true"
            @input="changeFilterData"
            :clear-item="clearItem"
            data-qa="selectClusterLocationToBP"
        />
      </div>
      <div class="baseprice-monitor-filter-panel__item select-item" v-show="showClusterContainer">
        <ObSelect
            v-model="filterData.agglomerationFrom"
            label="Агломерация откуда"
            placeholder="Укажите агломерацию"
            :value-exp="'clusterFromUuid'"
            :display-exp="'titleFrom'"
            :items="agglomerationsFromList"
            :is-auto-complete="false"
            @input="changeFilterData"
            data-qa="selectAglomerationFromBP"
        />
      </div>
    <div class="baseprice-monitor-filter-panel__item select-item" v-show="showClusterContainer">
        <ObSelect
            v-model="filterData.agglomerationTo"
            label="Агломерация куда"
            placeholder="Укажите агломерацию"
            :value-exp="'clusterToUuid'"
            :display-exp="'titleTo'"
            :items="agglomerationsToList"
            :is-auto-complete="false"
            @input="changeFilterData"
            data-qa="selectAglomerationToBP"
        />
      </div>
      <div class="baseprice-monitor-filter-panel__item clear-item">
        <ObButton
          class="clearFilter"
          label="Очистить"
          type="flat"
          icon="trash-sm"
          @click="clearFilter()"
          data-qa="buttonClearFilterBP"
        />
      </div>
  </div>
</template>

<script>
import api from '@/api'
import ObAddressInput from 'common-components/src/obComponents/obAddressInput';
import ObRadio from 'common-components/src/obComponents/obRadio';
import ObControlGroup from 'common-components/src/obComponents/obControlGroup';
import ObSelect from 'common-components/src/obComponents/obSelect';
import ObButton from 'common-components/src/obComponents/obButton';
import { transportationTypes } from "@/constants/basePrice.js";
import { getIconByLocation } from '@/helpers';
import _ from 'lodash';

const initFilterData = {
  transportationWay: 'FTL',
  locationFrom: null,
  locationTo: null,
  clusterLocationTo: null,
  clusterLocationFrom: null,
  cluster: null,
  agglomerationFrom: null,
  agglomerationTo: null,
  viewMode: 'cluster',
}

export default {
  name: 'basePricesFilterPanel',
  components: {
    ObAddressInput,
    ObRadio,
    ObControlGroup,
    ObSelect,
    ObButton,
  },
  props: {
    type: {
      type: String,
      default: () => 'LOCATION',
    },
  },
  data() {
    return {
      filterData: { ...initFilterData, type: this.type },
      groupItems: transportationTypes,
      locationsForSelect: [],
      clustersList: [],
      clearItem: {
        russian_name: 'Не выбрано',
        uuid: null
      },
      agglomerationsList: [],
    }
  },
  watch: {
    'filterData.transportationWay' () {
      this.filterData.cluster = null;
      this.filterData.agglomerationFrom = null;
      this.filterData.agglomerationTo = null;
      if ( this.filterData.transportationWay === 'CONTAINER' ) {
        this.getClusterContainers();
      }
    },
    'filterData.cluster' () {
      this.filterData.clusterLocationTo = null;
      this.filterData.clusterLocationFrom = null;
    },
    'filterData.clusterLocationFrom' () {
      this.filterData.clusterLocationTo = null;
    },
  },
  computed: {
    clustersFiltered() {
      return this.clustersList.filter( el => el.transportationWay === this.filterData.transportationWay );
    },
    locationsFrom() {
      let cluster = this.clustersList.find( cluster => cluster.uuid === this.filterData.cluster );
      if (cluster && cluster.directions) {
        return this.locationsForSelect.filter((location) => {
          return cluster.directions.find((direction) => {
            return direction.locationFromUuid === location.uuid;
          });
        });
      } else {
        return [];
      }
    },
    locationsTo() {
      let cluster = this.clustersList.find( cluster => cluster.uuid === this.filterData.cluster );
      if (cluster && cluster.directions) {
        return this.locationsForSelect.filter((location) => {
          if(this.filterData.clusterLocationFrom) {
            let direction = cluster.directions.find((direction) => {
              return direction.locationFromUuid === this.filterData.clusterLocationFrom;
            });
            return direction.locationsTo.find((loc) => {
              return loc.locationUuid === location.uuid;
            });
          } else {
            let locs = [];
            cluster.directions.map((direction) => {
              if(direction.locationsTo){
                locs = locs.concat(direction.locationsTo);
              }
            });
            return locs.find((loc) => {
              return loc.locationUuid === location.uuid;
            });
          }
        });
      } else {
        return [];
      }
    },
    showClusterFTL() {
      return this.filterData.type === 'CLUSTER' && this.filterData.transportationWay === 'FTL';
    },
    showClusterContainer() {
      return this.filterData.type === 'CLUSTER' && this.filterData.transportationWay === 'CONTAINER';
    },
    agglomerationsFromList() {
      let aggFrom = [{
        titleFrom: 'Все',
        clusterFromUuid: null,
        icon: 'aglomeration',
      }];
      if( this.filterData.agglomerationTo ) {
        aggFrom = aggFrom.concat(this.agglomerationsList.filter(agg => agg.clusterToUuid === this.filterData.agglomerationTo));
      } else {
        aggFrom = aggFrom.concat(this.agglomerationsList);
      }
      aggFrom = aggFrom.map((item, index) => {
        return{
          ...item,
          icon: item.categoryFrom === 'REFERENCE_POSITION' ? 'city-sm' : 'aglomeration',
          key: index,
        }
      });
      return _.uniqBy(aggFrom, 'clusterFromUuid');
    },
    agglomerationsToList() {
      let aggTo = [{
        titleTo: 'Все',
        clusterToUuid: null,
        icon: 'aglomeration',
      }];
      if( this.filterData.agglomerationFrom ) {
        aggTo =  aggTo.concat(this.agglomerationsList.filter(agg => agg.clusterFromUuid === this.filterData.agglomerationFrom));
      } else {
        aggTo =  aggTo.concat(this.agglomerationsList, 'clusterToUuid');
      }
      aggTo = aggTo.map((item, index) => {
        return {
          ...item,
          icon: item.categoryTo === 'REFERENCE_POSITION' ? 'city-sm' : 'aglomeration',
          key: index,
        };
      });
      return _.uniqBy(aggTo, 'clusterToUuid');
    },
  },
  methods: {
    setAddressFrom(location) {
      if (location.locationUuid) {
        this.filterData.locationFrom = location;
        this.filterData.locationFrom.icon = getIconByLocation(location.location_type_uuid);
        this.changeFilterData();
      } else {
        console.error('location doesnt have uuid');
      }
    },
    setAddressTo(location) {
      if (location.locationUuid) {
        this.filterData.locationTo = location;
        this.filterData.locationTo.icon = getIconByLocation(location.location_type_uuid);
        this.changeFilterData();
      } else {
        console.error('location doesnt have uuid');
      }
    },
    changeFilterData() {
      // если locationFrom == locationTo то это внутригородские перевозки
      if ( this.filterData.type === 'LOCATION' &&
           this.filterData.locationFrom?.locationUuid &&
           this.filterData.locationTo?.locationUuid &&
           this.filterData.locationFrom?.locationUuid === this.filterData.locationTo?.locationUuid
      ) {
        this.filterData.viewMode = 'intracity';
      } else if ( this.filterData.type === 'CLUSTER' && this.filterData.transportationWay === 'CONTAINER' ) {
        this.filterData.viewMode = 'container';
      } else if (this.filterData.type === 'CLUSTER') {
        this.filterData.viewMode = 'cluster';
      } else {
        this.filterData.viewMode = 'locations';
      }
      this.$emit('change', this.filterData);
    },
    async getLocations() {
      try {
        const data = await api.locations.getLocations(0, 10000, '', [], {location_type_uuid: '5919a99f-d840-4855-b158-5ba957076603'});
        this.locationsForSelect = data.data.content;
      } catch (e) {
        this.$notification({
          type: 'system_notification_error',
          message: 'Ошибка загрузки данных'
        })
        return [];
      }
    },
    async getClusters() {
      try {
        const data = await api.base_prices_clustering.getDirectionsGroups( { page_size: 10000, page_num: 0 });
        data.content = data.content.map((item) => {
          return {
            ...item,
            icon: 'aglomeration',
          }
        });
        this.clustersList = data.content;
      } catch (e) {
        this.$notification({
          type: 'system_notification_error',
          message: 'Ошибка загрузки данных'
        })
        return [];
      }
    },
    async getClusterContainers() {
      try {
        const agglomerations = await api.locations.getRaylwayAgglomerations();
        const data = await api.base_prices_clustering.getContainerAgglomerations();
        this.agglomerationsList = data.content.map((item) => {
          return {
            ...item,
            icon: 'aglomeration',
            titleFrom: this.getTitleForAglomeration(item.clusterFromUuid, agglomerations),
            titleTo: this.getTitleForAglomeration(item.clusterToUuid, agglomerations),
          }
        });

      } catch (e) {
        console.error(e);
        this.$notification({
          type: 'system_notification_error',
          message: 'Ошибка загрузки данных'
        })
        return [];
      }
    },
    getTitleForAglomeration (clusterUuid, agglomerations) {
      let title = '';
      const agglomeration = agglomerations.find(agg => agg.uuid === clusterUuid);
      if (agglomeration?.title) {
        title = agglomeration.title;
      } else {
        let locationFrom = this.locationsForSelect.find((location => location.uuid === clusterUuid));
        if (locationFrom) {
          title = locationFrom.title;
        }
      }
      return title;
    },
    clearFilter() {
      this.filterData = { ...initFilterData, type: this.type };
      this.$refs.locationFromInput.onClearInput();
      this.$refs.locationToInput.onClearInput();
      this.$emit('change', this.filterData);
    },
  },
  async created() {
    await this.getLocations();
    await this.getClusters();
    // await this.getClusterContainers();
  },
}
</script>

<style lang="scss" scoped>
.baseprice-monitor-filter-panel {
  display: flex;
  flex-wrap: wrap;
  width: 100%;
  gap: 20px;
  padding: 20px;
  align-items: center;

  &__item{

    &.select-item{
      flex-basis: 230px;
      max-width: 300px;
      flex-grow: 1;
    }
  }

  &::v-deep {
    .ob-radio-container:first-child{
      margin-bottom: 5px;
    }

    .clearFilter{
      color: $gray-window;
    }
  }
}
</style>